<as-popup
    #popup
></as-popup>
<div class="description">
    <h3>Комментарии к реализации</h3>
    <ol>
        <li>Использовать готовые реализации (select2) было нерекомендовано.</li>
        <li>Сторонние бибиотеки не используются вовсе. <small>Раз готовые реализации использовать нельзя, тогда не используем реализации вообще.</small></li>
        <li>
            Иконки скачать не смог. Взял из awesome-font. 
            <small>
                Пытался взять отсюда <a href="https://ui.skbkontur.ru/eco/Icons/font/webfonts/Kontur-Iconic-eco-20px.ttf">https://ui.skbkontur.ru/eco/Icons/font/webfonts/Kontur-Iconic-eco-20px.ttf</a>.
            </small>
        </li>
        <li>Затраченное время: вторник (11.07), четверг (13.07), пятница (14.07), суббота (15.07), воскресенье (16.07, полдня</li>
        <li>Доводить до продакшен я не готов. Известные мне проблемы описаны ниже.</li>
        <li>Верстать я не люблю и не умею. Чуство прекрасного для верстки отсутсвует=).</li>
        <li>Суммарно на верстку израсходовано часов 8. Еще раз убедился - не мое.</li>
        <li>Я преданный адепт TypeScript (и снова Microsoft). Причина - частичная статическая типизация. Это круто! Ну и возможность транспилинга в любой ES (хотя есть Babel) - это тоже очень здорово.</li>
    </ol>
</div>
<div class="problems">
    <h3>Известные проблемы</h3>
    <ol>
        <li>Частичная загрузка не сделана. Вызывает значительный лаг (2 секунды) при отображении полного списка и проблемы с работой с клавиатуры.</li>
        <li>Попап не связан с компонентом и абсолютный div c ним добавлен не в body. Думаю, следует переделать на директиву, динамически добавлять попап в компоненте в body.</li>
        <li>Высота попапа при некоторых условиях (не нашел) высчитывается не корректно.</li>
    </ol>
</div>
<div class="comment">
    <h3>Комментарии к постановке</h3>
    <ol>
        <li>Пункт 59 не согласован с пунктом 14.</li>
        <li>Четко не сказано, связано ли название (caption) поля с компонентом или нет. Считаю, что связано.</li>
        <li>Четко не сказано, есть ли обязательные поля. Считаю, что есть.</li>
        <li>Не понятно как выглядит предупреждение по умолчанию, предупреждение и мышка над, ошибка, ошибка и мышка над.</li>
        <li>Не прописано состояние: выполняется проверка корректности значения. Считаю, что нет.</li>
        <li>Не прописаны способы программной установки значений и получения значения - это id или само значение. Можно программно устанавливать значения и по id и по text, выполеняется валидация с проверкой</li>
        <li>Возвращаемый объект - пара значений id и text. Нужно например для Первомайской.</li>
        <li>Пункт 26 усложнен и сделан по другому - если список загрузится не успел и значение есть в списке - ОК, иначе ошибка. Причина - необходимость программной установки значений</li>
    </ol>
</div>
<div class="app">
    <h3>Примеры</h3>
    <h4>Подпись</h4>
    <h6>Есть</h6>
    <as-autocomplete
        [caption]="'Выберите населенный пункт'"
        [datasource]="kladrService"
        [popup]="popup"
    ></as-autocomplete>
    <h6>Есть, длинная</h6>
    <as-autocomplete
        [caption]="'Выберите населенный пункт в котором находится налоговыдный космодром'"
        [datasource]="kladrService"
        [popup]="popup"
    ></as-autocomplete>
    <h6>Нет</h6>
    <as-autocomplete
        [popup]="popup"
        [datasource]="kladrService"
    ></as-autocomplete>
    <h4>Плейсхолдер</h4>
    <h6>Заданый</h6>
    <as-autocomplete
        [caption]="'Выберите населенный пункт'"
        [placeholder]="'Выбирайте космодром'"
        [datasource]="kladrService"
        [popup]="popup"
    ></as-autocomplete>
    <h6>По умолчанию</h6>
    <as-autocomplete
        [caption]="'Выберите населенный пункт'"
        [datasource]="kladrService"
        [popup]="popup"
    ></as-autocomplete>
    <h4>Обязательное поле</h4>
    <h6>Да</h6>
    <as-autocomplete
        [caption]="'Выберите населенный пункт'"
        [required]="true"
        [datasource]="kladrService"
        [popup]="popup"
    ></as-autocomplete>
    <h6>Нет</h6>
    <as-autocomplete
        [caption]="'Выберите населенный пункт'"
        [datasource]="kladrService"
        [popup]="popup"
    ></as-autocomplete>
    <h4>Размер</h4>
    <h6>Большой</h6>
    <as-autocomplete
        [caption]="'Выберите населенный пункт'"
        [size]="2"
        [datasource]="kladrService"
        [popup]="popup"
    ></as-autocomplete>
    <h6>Средний</h6>
    <as-autocomplete
        [caption]="'Выберите населенный пункт'"
        [size]="1"
        [datasource]="kladrService"
        [popup]="popup"
    ></as-autocomplete>
    <h6>Маленький</h6>
    <as-autocomplete
        [caption]="'Выберите населенный пункт'"
        [size]="0"
        [datasource]="kladrService"
        [popup]="popup"
    ></as-autocomplete>
    <h4>Способ выбора</h4>
    <h6>Все варианты</h6>
    <as-autocomplete
        [caption]="'Выберите населенный пункт'"
        [arrow-style]="1"
        [datasource]="kladrService"
        [popup]="popup"
    ></as-autocomplete>
    <h6>Фильтрованный</h6>
    <as-autocomplete
        [caption]="'Выберите населенный пункт'"
        [arrow-style]="0"
        [datasource]="kladrService"
        [popup]="popup"
    ></as-autocomplete>
    <h4>Значение по умолчанию (программная установка)</h4>
    <h6>По id, успех</h6>
    <as-autocomplete
        [caption]="'Выберите населенный пункт'"
        [selectedId]="5"
        [datasource]="kladrService"
        [popup]="popup"
    ></as-autocomplete>
    <h6>По id, провал</h6>
    <as-autocomplete
        [caption]="'Выберите населенный пункт'"
        [selectedId]="-1"
        [datasource]="kladrService"
        [popup]="popup"
    ></as-autocomplete>
    <h6>По text, успех</h6>
    <as-autocomplete
        [caption]="'Выберите населенный пункт'"
        [selectedText]="'Пермь  '"
        [datasource]="kladrService"
        [popup]="popup"
    ></as-autocomplete>
    <h6>По text, провал (Первомайский - много таких)</h6>
    <as-autocomplete
        [caption]="'Выберите населенный пункт'"
        [selectedText]="'Первомайский'"
        [datasource]="kladrService"
        [popup]="popup"
    ></as-autocomplete>
    <h6>По text, провал (ЕкатеринбургЧАЙФ - нет такого)</h6>
    <as-autocomplete
        [caption]="'Выберите населенный пункт'"
        [selectedText]="'ЕкатеринбургЧАЙФ'"
        [datasource]="kladrService"
        [popup]="popup"
    ></as-autocomplete>
    <h4>Не привязан datasource</h4>
    <as-autocomplete
        [caption]="'Выберите населенный пункт'"
        [arrow-style]="1"
        [selectedText]="'ЕкатеринбургЧАЙФ'"
        [popup]="popup"
    ></as-autocomplete>
    <h4>Не активный компонент</h4>
    <h6>datasource есть, значение правильное</h6>
    <as-autocomplete
        [caption]="'Выберите населенный пункт'"
        [datasource]="kladrService"
        [enabled]="false"
        [required]="true"
        [arrow-style]="1"
        [selectedText]="'Екатеринбург'"
        [popup]="popup"
    ></as-autocomplete>
    <h6>datasource нет, значение не правильное</h6>
    <as-autocomplete
        [caption]="'Выберите населенный пункт'"
        [enabled]="false"
        [required]="true"
        [arrow-style]="1"
        [selectedText]="''"
        [popup]="popup"
    ></as-autocomplete>
</div>